# -*- coding: iso-8859-15 -*-
# modifie par Daniel Poiraud, AVH16. version 3.3 du 22/04/2022.
import winUser
from winUser import *
import api
import appModuleHandler
import speech
from scriptHandler import getLastScriptRepeatCount
from ui import message
import ctypes
from ctypes import windll
from ctypes import * 
from ctypes.wintypes import * 
from keyboardHandler import KeyboardInputGesture
from NVDAObjects import NVDAObject
from NVDAObjects.window import Window
from NVDAObjects.IAccessible import sysListView32, IAccessible, getNVDAObjectFromEvent, getNVDAObjectFromPoint
from time import sleep
import wx
import windowUtils
import displayModel
#import watchdog 
from UIAHandler import handler
clientObject = handler.clientObject

user32 = windll.user32
UIA_BoundingRectanglePropertyId, UIA_ControlTypePropertyId, UIA_NamePropertyId = 30001, 30003, 30005
UIA_AutomationIdPropertyId, UIA_ValueValuePropertyId = 30011, 30045
UIA_ButtonControlTypeId, UIA_ComboBoxControlTypeId, UIA_EditControlTypeId, UIA_ListControlTypeId, UIA_PaneControlTypeId = 50000, 50003, 50004, 50008, 50033 
hdMain=user32.GetForegroundWindow() 

def getSpeechMode():
	try:
		return speech.getState().speechMode
	except AttributeError:
		return speech.speechMode
def setSpeechMode(mode):
	try:
		speech.setSpeechMode(mode)
	except AttributeError:
		speech.speechMode = mode

def setSpeechMode_off():
	try:
		speech.setSpeechMode(speech.SpeechMode.off)
	except AttributeError:
		speech.speechMode = speech.speechMode_off

def clicGauche (x,y):
	winUser.setCursorPos(int(x),int(y))
	winUser.mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,None,None) 
	winUser.mouse_event(MOUSEEVENTF_LEFTUP,0,0,None,None)  
				
def affichageVolet ():
	try :
		hd1 = windowUtils.findDescendantWindow(user32.GetForegroundWindow(),visible= True,className="Outlook Express Message View")
		hd2 = windowUtils.findDescendantWindow(hd1,visible= True,className="PreviewPane")		
	except :
		message (u"Un problme a t rencontr")
		return	
	oCondition1  =clientObject.CreatePropertyCondition(UIA_ControlTypePropertyId,UIA_EditControlTypeId)
	oCondition2  =clientObject.CreatePropertyCondition(UIA_NamePropertyId,"Objet :")
	oCondition  =clientObject.CreateAndCondition(oCondition1,oCondition2)
	element = clientObject.ElementFromHandle(hd2).FindFirst(4,oCondition)	
	if not element or element.GetCurrentPropertyValue(UIA_ValueValuePropertyId)=="":
		return 0
	else : return 1

class PourEnTetes() :

	def __init__(self):
		self.i2009 = self.nomClass = self.nomObj = self.nomBoutonTest = None
		obj = api.getFocusObject() 
		versionWLM = obj.appModule.productVersion.split(".")[0]
		self.i2009 = self.nomClass = self.nomObj = self.nomBoutonTest = None
		if versionWLM == "14" :
			self.i2009, self.nomClass, self.nomObj, self.nomBoutonTest = 1, "DirectUIHWND", "Objet :", "Format" 
		else :
			self.i2009, self.nomClass, self.nomObj, self.nomBoutonTest = 0, "WLXDUI", u" :", "Envoyer ce message maintenant"
		
	def dansFenetreRedaction(self):
		if not (getClassName(user32.GetForegroundWindow())=="ATH_Note") :
			return 0		
		try:
			oCondition1  =clientObject.CreatePropertyCondition(UIA_ControlTypePropertyId,UIA_ButtonControlTypeId)
			oCondition2  =clientObject.CreatePropertyCondition(UIA_NamePropertyId,self.nomBoutonTest)
			oCondition  =clientObject.CreateAndCondition(oCondition1,oCondition2) 
			if not clientObject.ElementFromHandle(user32.GetForegroundWindow()).FindFirst(4,oCondition):
					return 0
			else : return 1
		except: return 0
		
	def enTete(self,k): 
		hdMain, hd0, hd1, o = user32.GetForegroundWindow(),None, None, None
		if getClassName(hdMain)=="Outlook Express Browser Class" and not affichageVolet ():   
			message(u"Le volet n'est pas affich.")
			return	
		try:	
			if getClassName(hdMain)=="Outlook Express Browser Class" : 
				hd1 = windowUtils.findDescendantWindow(hdMain,visible= True,className="PreviewPane")
			if getClassName(hdMain)=="ATH_Note" : 
				hd1 = windowUtils.findDescendantWindow(hdMain,visible= True,className="Note Native Class")	
		except :
			message(u"Zone des en-ttes non trouve.")
			return 	
		if hd1 :
			try :
				hd0 = windowUtils.findDescendantWindow(hd1,visible= True,className=self.nomClass)
			except :
				message(u"Zone des en-ttes non trouve.")
				return
						
		if k ==7 :	
			if self.dansFenetreRedaction() :
				try :
					oCondition1  =clientObject.CreatePropertyCondition(UIA_AutomationIdPropertyId,"1000")
					oCondition2  =clientObject.CreatePropertyCondition(UIA_ControlTypePropertyId,UIA_ListControlTypeId)  
					oCondition  =clientObject.CreateAndCondition(oCondition1, oCondition2)
					element = clientObject.ElementFromHandle(hdMain).FindFirst(4,oCondition)
					if not element : 	
						message(u"Pas de pice jointe.")
						return
					else :	
						(x,y,l,h) =element.GetCurrentPropertyValue(UIA_BoundingRectanglePropertyId)
						o =  getNVDAObjectFromPoint(int(x)+20, int(y)+8)
						message(u"Pice jointe.")
				except : return
			if not self.dansFenetreRedaction() :
				try :
					oCondition1  =clientObject.CreatePropertyCondition(UIA_ControlTypePropertyId,UIA_EditControlTypeId)
					oCondition2  =clientObject.CreatePropertyCondition(UIA_NamePropertyId,self.nomObj)	
					oCondition  =clientObject.CreateAndCondition(oCondition1,oCondition2)
					element = clientObject.ElementFromHandle(hd0).FindFirst(4,oCondition)	
					if not element :
						message("Zone non atteinte.") 
						return				
					(x,y,l,h) =element.GetCurrentPropertyValue(UIA_BoundingRectanglePropertyId)
					o =  getNVDAObjectFromPoint(int(x)+20, int(y)+8)
					if (self.i2009==0 and not o.next) or (self.i2009==1 and o.previous.role==8):
						message(u"Pas de pice jointe.")
						return
					else : message(u"Pice jointe.")	
				except : return
			if getLastScriptRepeatCount() ==1 :
				if not self.dansFenetreRedaction() :
					if 	self.i2009==1 :	
						o = o.previous
					else:	
						o = o.next
						if o.role==8 : o=o.next				
				(x,y,l,h) =o.location
				clicGauche (int(x+l/2),int(y+h/2))
			return

		sName = [0,"Nom du contact","Date :",u" :","Cc :","Cci :","Objet :"] 			
		if 	self.dansFenetreRedaction() :
			sName[1] = "De :"
		try :
			oCondition1  =clientObject.CreatePropertyCondition(UIA_ControlTypePropertyId,UIA_ButtonControlTypeId)
			oCondition2  =clientObject.CreatePropertyCondition(UIA_ControlTypePropertyId,UIA_ComboBoxControlTypeId)
			oCondition3  =clientObject.CreatePropertyCondition(UIA_ControlTypePropertyId,UIA_EditControlTypeId)
			oCondition10  =clientObject.CreateOrCondition(oCondition1,oCondition2)
			oCondition11  =clientObject.CreateOrCondition(oCondition10,oCondition3)
			oCondition4  =clientObject.CreatePropertyCondition(UIA_NamePropertyId,sName[k])
			oCondition  =clientObject.CreateAndCondition(oCondition11,oCondition4) 
			element = clientObject.ElementFromHandle(hd0).FindFirst(4,oCondition) 
			if not element: 
				message(u"Champ %s non trouv." %sName[k])  	
				return
		except : return	
		if (element.CurrentName):  texte0 =element.CurrentName
		texte = texte0+", "+element.GetCurrentPropertyValue(UIA_ValueValuePropertyId) 
		if getLastScriptRepeatCount() ==0 :
			try :
				att = wx.CallLater(0,message(texte))  #300
			except :
				pass
		# double frappe	
		else :
			if k==2: return
			(x,y,l,h) =element.GetCurrentPropertyValue(UIA_BoundingRectanglePropertyId)		
			iX =int(x)+50
			iY = int(y)+8
			clicGauche (iX,iY) 
			sleep(0.5)
			if k==1 and self.dansFenetreRedaction() :
				texte =u" focalis." 
			else :
				texte =texte0+u" focalis."  
				sleep(0.2)
			message(texte)
			if not (k==1 and self.dansFenetreRedaction()) : 
				oldSpeechMode = getSpeechMode()
				setSpeechMode_off()
				sleep(0.1)
				api.processPendingEvents()
				sleep(0.3)
				setSpeechMode(oldSpeechMode)
						
	def lireContenu(self):
		hdMain=user32.GetForegroundWindow()
		if winUser.getClassName(hdMain)=="ATH_Note" or (winUser.getClassName(hdMain)=="Outlook Express Browser Class" and affichageVolet()):
			try :
				hd1 = windowUtils.findDescendantWindow(hdMain,visible= True, controlID=1000)
				hd = windowUtils.findDescendantWindow(hd1,visible= True, className="Internet Explorer_Server")
				oCondition  =clientObject.CreateTrueCondition()
				elements = clientObject.ElementFromHandle(hd).FindAll(4,oCondition)
				if elements.Length :
					texte = ""
					for i in list(range (0, elements.Length)):
						texte = texte+elements.GetElement(i).CurrentName+" "
					message (texte)
				else :
					message ("Contenu vide ou non atteint")	
			except :
				message ("Zone de contenu non atteinte")	
